/**************************************************************************
 *  enumerator - a program to enumerate large implicit search spaces      *
 *  Copyright (C) 2007-2008  Eric Robinson                                *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  (at your option) any later version.                                   *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#ifndef SEARCHINTERFACE_H_
#define SEARCHINTERFACE_H_

#include "ArchitectureInterface.h"
#include "ProblemInterface.h"

class SearchInterface
{
protected:
	UINT64 DataAccess;
	UINT64 GeneratorsApplied;
	
public:
	enum RUN_MODE
	{
		RUN_REPORT,
		RUN_ENUMERATE,
		RUN_RESUME
	};
	
	virtual bool Run( 	ProblemInterface *problem, 
						ArchitectureInterface *architecture, 
						RUN_MODE run,
						int *pargc, 
						char ***pargv ) = 0;
};

#endif /*SEARCHINTERFACE_H_*/
