/**************************************************************************
 *  enumerator - a program to enumerate large implicit search spaces      *
 *  Copyright (C) 2007-2008  Eric Robinson                                *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  (at your option) any later version.                                   *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <stdarg.h>
#include <time.h>
#include "tivstand.h"
#include "tivcheck.h"

UINT32 tivlogDebugLevel = 0;

FILE *output;

bool init_log( CHAR *filename, UINT32 level )
{
   tivlogDebugLevel = level;
   if( !filename ) output = stdout;
   else fopen_check( output, filename, "w" );
   return true;
}

void close_log( )
{
   fclose( output );
}

#define log_string( level, params )                                            \
   if( level <= tivlogDebugLevel ) ( do_log params )

void do_log( const CHAR *message,... )
{
   CHAR buf[1000];
   va_list vl_vars;
   struct timeval s_time;

   va_start( vl_vars, message );
   gettimeofday( &s_time, NULL );
   ctime_r( &( s_time.tv_sec ), buf );
   buf[strlen( buf ) - 1] = '\0';
   strcat( buf, ": " );
   strcat( buf, message );
   vfprintf( output, buf, vl_vars );
   fflush( output );
}
