/**************************************************************************
 *  enumerator - a program to enumerate large implicit search spaces      *
 *  Copyright (C) 2007-2008  Eric Robinson                                *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  (at your option) any later version.                                   *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

#ifndef TIVMATH_H_
#define TIVMATH_H_

#include "tivstand.h"

#define MAX( x, y ) ( (x) > (y) ? (x) : (y) )
#define MIN( x, y ) ( (x) < (y) ? (x) : (y) )

static INT64 power( INT64 base, UINT32 exponent )
{
	INT64 solution;

	if( exponent == 0 ) return 1;
	if( exponent == 1 ) return base;

	solution = power ( base, exponent / 2 );

	return solution * solution * power ( base , exponent % 2 );
}

static INT64 log( UINT64 base, INT64 number )
{
   UINT64 exponent;
   
   for( exponent = 0; number /= base; exponent++ );
   
   return exponent;
}

#endif /*TIVMATH_H_*/

