#include "mpi.h"
#include "mpiimpl.h"

int MPI_Allreduce ( sendbuf, recvbuf, count, datatype, op, comm) 
     void *sendbuf; 
     void *recvbuf;
     int count;
     MPI_Datatype datatype;
     MPI_Op op;
     MPI_Comm comm;
{
  /* all processes receive results of the reduction operation, not just the
     root, so broadcast the result which is in root's recvbuf. result will
     end up in all other processes' recvbuf */
  MPI_Reduce(sendbuf, recvbuf, count, datatype, op, 0, comm);
  MPI_Bcast(recvbuf, count, datatype, 0, comm);
}
