#include "mpi.h"
#include "mpiimpl.h"

int MPI_Bcast (
    void             *buffer,
    int               count,
    MPI_Datatype      datatype,
    int               root,
    MPI_Comm          comm)
{
  int dest_rank;
  MPI_Status status;

  if (MPINU_myrank == root)
  {
    for ( dest_rank = 0; dest_rank <= MPINU_num_slaves; dest_rank++ )
      if (dest_rank != root)
	MPINU_Int_Send(buffer, count, datatype, dest_rank, MPINU_BCAST_TAG,
	    comm);
  }
  else
    MPINU_Int_Recv(buffer, count, datatype, root, MPINU_BCAST_TAG, comm,
	&status);

  return MPI_SUCCESS;
}
