#include "mpi.h"
#include "mpiimpl.h"

int MPI_Gather (
     void              *sendbuf,
     int               sendcount,
     MPI_Datatype      sendtype,
     void              *recvbuf,
     int               recvcount,
     MPI_Datatype      recvtype,
     int               root,
     MPI_Comm          comm)
{
  int dest_rank;
  MPI_Status status;

  /* everybody sends what's in sendbuf including root */
  MPINU_Int_Send(sendbuf, sendcount, sendtype, root, MPINU_GATHER_TAG, comm);

  /* root receives from all nodes */
  if (MPINU_myrank == root)
    {
      for ( dest_rank = 0; dest_rank <= MPINU_num_slaves; dest_rank++ ) {
	char *rb = (char *)recvbuf;
	rb += (dest_rank*MPINU_msg_size(recvcount,recvtype));
	MPINU_Int_Recv(rb, recvcount, recvtype, dest_rank, MPINU_GATHER_TAG,
	    comm, &status);
      }
    }

  return MPI_SUCCESS;
}
