#include "mpi.h"
#include "mpiimpl.h"

int MPI_Gatherv (
     void *sendbuf,
     int sendcnt,
     MPI_Datatype sendtype,
     void *recvbuf,
     int *recvcnts,
     int *displs,
     MPI_Datatype recvtype,
     int root,
     MPI_Comm comm)
{
  int dest_rank;
  MPI_Status status;

  /* all nodes sends what's in sendbuf which has count sendcnt */
  MPINU_Int_Send(sendbuf, sendcnt, sendtype, root, MPINU_GATHERV_TAG, comm);

  /* root receives all messages and saves it in recvbuf */
  if (MPINU_myrank == root)
    {
      for ( dest_rank = 0; dest_rank <= MPINU_num_slaves; dest_rank++ ) {
	char *rb = (char *)recvbuf;
	rb += (displs[dest_rank]*MPINU_datatype_size(recvtype));
	MPINU_Int_Recv(rb, recvcnts[dest_rank], recvtype, dest_rank,
	    MPINU_GATHERV_TAG, comm, &status);
      }
    }

  return MPI_SUCCESS;
}
