#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"

/* test for MPI_Reduce on MPI_BOR operation */

enum types { TCHAR, TINT, TUINT, TDOUBLE };
void init_buffer(void *buf, int count, int type);

int main(argc, argv)
     int argc;
     char *argv[];

{	
  int myrank; /* SunOS has problems with this local decl. */
  MPI_Init(&argc, &argv);		/* initialize MPI */
  MPI_Comm_rank(MPI_COMM_WORLD,	&myrank);	/* process rank, 0 thru N-1 */

  int i;
  int ntasks;

  MPI_Comm_size(MPI_COMM_WORLD,   /* always use this */
		&ntasks);  

  int *sendbuf = (int*)malloc(sizeof(int)*ntasks);        
  int *recvbuf = (int*)malloc(sizeof(int)*ntasks);        
  
  /*  init_buffer(sendbuf, ntasks, TINT); */
  for (i=0; i<ntasks; i++) 
    sendbuf[i] = (myrank + 1) * i;

  printf("myrank : %d  sendbuf: ", myrank);
  for (i=0; i<ntasks; i++) 
    printf("%d ", sendbuf[i]);
  printf("\n");

  MPI_Reduce(sendbuf, recvbuf, ntasks, MPI_INT, MPI_BOR, 0, MPI_COMM_WORLD);
   
  if (myrank == 0) 
    {      
      for (i=0; i<ntasks; i++) 
	printf(" %d\n", recvbuf[i]);
    }

  MPI_Finalize();			/* cleanup MPI */
  exit(0);
}

/* function for initializing buffers with data depending on type */
void init_buffer(void *buf, int count, int type)
{
  long i;
  switch (type)
    {
    case TCHAR:
      for(i=0; i<count; i++)
        ((char*)buf)[i]=(char)(i%26)+65;
      break;

    case TINT:
      for(i=0; i<count; i++)
        ((int*)buf)[i]=i+1;
      break;

    case TUINT:
      for(i=0; i<count; i++)
        ((unsigned int*)buf)[i]=(unsigned int)i+1;
      break;

    case TDOUBLE:
      for(i=0; i<count; i++)
        ((double*)buf)[i]=(double)i+1;
      break;
    }
}
