#include <stdio.h>
#include <assert.h>
#include <unistd.h>
#include "mpi.h"

#define ITERATIONS	5

/*
 * Name:	hello_mpi1
 *
 * Purpose:	verify that following MPI_Init(), no messages are found
 *		anywhere in the system.
 *
 * Slaves:	> 1, so that some MPI internal setup communication must have
 *		occurred.
 */
int main( int argc, char *argv[] ) {
  int		flag, i;
  MPI_Status	status;

  MPI_Init( &argc, &argv );		/* initialize MPI */

  /*
   * No messages should be available anywhere.
   */
  for ( i = 0; i < ITERATIONS; i++ ) {
    MPI_Iprobe( MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &flag, &status );
    assert( 0 == flag );
    sleep( 2 );
  }

  MPI_Finalize();			/* cleanup MPI */
  return 0;
}
