#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <pthread.h>
#include "mpi.h"

static void *check( void *arg ) {
  int flag;
  assert( MPI_SUCCESS == MPI_Is_thread_main( &flag ) );
  assert( flag );
  return NULL;
}

/*
 * Name:	th_init1
 *
 * Purpose:	Verify behavior of MPI_Init(), MPI_Query_thread() and
 *		MPI_Is_thread_main().
 *
 * Slaves:	Doesn't matter.
 */
int main( int argc, char *argv[] ) {
  int provided, flag;
  pthread_t thread;

  /* initialize MPI using the regular initialization function */
  assert( MPI_SUCCESS == MPI_Init( &argc, &argv ) );
  assert( MPI_SUCCESS == MPI_Query_thread( &provided ) );
  assert( MPI_THREAD_SINGLE == provided );
  assert( MPI_SUCCESS == MPI_Is_thread_main( &flag ) );
  assert( flag );

  assert( 0 == pthread_create( &thread, NULL, check, NULL ) );
  assert( 0 == pthread_join( thread, NULL ) );

  MPI_Finalize();			/* cleanup MPI */
  return 0;
}
